package eu.clarin.cmdi.mdservice.action;

import java.io.BufferedInputStream;
import java.io.BufferedReader;
import java.io.ByteArrayInputStream;
import java.io.ByteArrayOutputStream;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.IOException;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.io.Reader;
import java.io.Writer;
import java.net.MalformedURLException;
import java.net.URL;
import java.util.Enumeration;

import java.io.StringReader;
import java.io.StringWriter;

import javax.servlet.ServletInputStream;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpSession;
import javax.xml.parsers.DocumentBuilder;
import javax.xml.parsers.DocumentBuilderFactory;
import javax.xml.parsers.ParserConfigurationException;
import javax.xml.transform.OutputKeys;
import javax.xml.transform.Transformer;
import javax.xml.transform.TransformerConfigurationException;
import javax.xml.transform.TransformerException;
import javax.xml.transform.TransformerFactory;
import javax.xml.transform.TransformerFactoryConfigurationError;
import javax.xml.transform.dom.DOMSource;
import javax.xml.transform.stream.StreamResult;


import net.sf.json.JSON;
import net.sf.json.JSONArray;
import net.sf.json.JSONObject;
import net.sf.json.JSONSerializer;
import net.sf.json.xml.XMLSerializer;

import java.security.AccessController;
import java.security.PrivilegedActionException;
import java.security.PrivilegedExceptionAction;
//import javax.servlet.ServletInputStream;


import org.apache.struts2.interceptor.ServletRequestAware;
import org.w3c.dom.Document;
import org.w3c.dom.Node;
import org.w3c.dom.NodeList;
import org.xml.sax.InputSource;
import org.xml.sax.SAXException;

import com.opensymphony.xwork2.ActionSupport;


/**
 *
 * @author 
 *
 */
public class WorkspaceAction extends GenericProxyAction 
//implements ServletRequestAware 
{

	private static final long serialVersionUID = 1L;
	
	public static String USER = "user";
	public static String SERVER = "server";
	
	public static String PROFILENAME_BASE = "WorkspaceProfile_";
	public static String PROFILENAME_SERVER = "WorkspaceProfileServer.xml";
	public static String PROFILENAME_DEFAULT = PROFILENAME_BASE + "default.xml";
	/** 
	 * Properties to be filled by Struts with according request-parameters
	 */	
	//private String actionkey;
	private String data;
	private String type;
	//private String format;
	//private String userMsg;
	private String base_path;
	
	//private HttpServletRequest request; 
	
	public String getData(){
		return data;
	}

	public void setData(String data) {
		this.data = data;
	}

	public String getType() {
		return type;
	}

	public void setType(String type) {
		this.type = type;
	}
	/*
	public String getFormat() {
		return format;
	}

	public void setFormat(String format) {
		this.format = format;
	}
	
	public String getActionkey() {
		return actionkey;
	}

	public void setActionkey(String actionKey) {
		actionkey = actionKey;
	}
*/
	/**
	 * primitive identification of the target-proxy
	 * base for finding the right base_url in the props
	 * subclass has to override with its specific proxykey
	 * @return
	 */
	public String getProxyKey() {
		return "workspaceprofile";
	}

	/*
	@Override
	public void setServletRequest(HttpServletRequest arg0) {
		request = arg0;
		
	}

	@Override
	public HttpServletRequest getServletRequest() {
		return request;		
	}
*/
	/*
	public String getUserMsg() {
		return userMsg;
	}

	public void setUserMsg(String userMsg) {
		this.userMsg = this.userMsg + "\n" + userMsg;
	}


	private InputStream resultStream;
	private InputStream sourceStream;
*/
	/**
	 * The stream holding the resulting data to be sent back to the user as response
	 * @return
	 */
	/*
	public InputStream getResultStream() {
	        return resultStream;
    }
	public void setResultStream(InputStream _resultStream){
		resultStream = _resultStream;
	}
	public void setSourceStream(InputStream _sourceStream){
		sourceStream = _sourceStream;
	}
	*/
	@Override
	public URL getBaseURL() {
		File file=new File(getPath());
	    URL url=null;
	    try{
		    url=file.toURL(); 
		    Admin.notifyUser("DEBUG: WorkspaceAction.getBaseURL(): "  + url);
	    } catch (MalformedURLException e){
	    	Admin.notifyUser("JSON exception has been caught" + e);
	    }
	    
	    return url;
	}
	
	public String getBasePath() {		
		if (base_path == null) {
			base_path = Admin.getConfig().getProperty(getProxyKey() + ".path");
		}
		return base_path;
	}
	
	
	public String getWorkspaceProfile() {
		String profilename = null;
		
		if (type.toLowerCase().equals(USER)) {
			if (getServletRequest().getRemoteUser() != null) {
				profilename =  PROFILENAME_BASE + getServletRequest().getRemoteUser() + ".xml";
			} else {
				profilename = PROFILENAME_DEFAULT;
			}
		} else if (type.toLowerCase().equals(SERVER)) {
			profilename =  PROFILENAME_SERVER;
			/*
			File f = new File(getBasePath() + profilename);
			if (! f.exists()){
				//Admin.notifyUser(" not exists");
				profilename = "WorkspaceProfile_default.xml";
			}
			*/
		}
		
		if (profilename == null){
			profilename = PROFILENAME_DEFAULT;
			Admin.notifyUser("WorkspaceProfilePath not specified (USER, SERVER)!");
		}
		
		Admin.notifyUser("WorkspaceProfilename : " + profilename);
		return profilename;
	}
	
	@Override
	public String getFullFormat() {
		return "xml2json";
	}
	
	public URL getURL() {
		File file=new File(getPath());
	    URL url=null;
	    try{
		    url=file.toURL(); 
		    //Admin.notifyUser("url "  + url);
	    } catch (MalformedURLException e){
	    	//Admin.notifyUser("" + e);
	    }
		return url;
	}
	
	
	public String getPath() {
		String targetPath = getBasePath() + getWorkspaceProfile();	   
        Admin.notifyUser("WorkspaceAction TARGETPATH: " + targetPath);              
        return targetPath;
	}

	@Override
	public InputStream getSourceStream() throws IOException {	
		InputStream stream = new BufferedInputStream( new FileInputStream(getPath()));
	
		
		return   stream;
	}
	
	// set the server - session data =  repositories, termsets
	public void setSessionData(InputStream source) throws IOException {
		if (source == null) return;
		if (this.getWorkspaceProfile() != PROFILENAME_SERVER) return;
		
		
			
	}
	
	
	@Override
	public void prepare() throws Exception {		
		
		//Admin.notifyUser("execute:");
		InputStream in = getSourceStream();
		this.setSourceStream(in); 
		if (getFormat().equals("xml")) {			
			setResultStream(in);	
		}else { //JSON
			// set srcFile (for MDTransformer to pass to xsl-scripts) 
			MDTransformer transformer = new MDTransformer();
			transformer.setSrcFile(getURL());
			transformer.setParams(MDTransformer.createParamsMap(getFullFormat()));
			setResultStream(transformer.transformXML(in));//, getFullFormat()));
			//setSessionData(getResultStream());
		}
			
		Admin.notifyUser(getProxyKey() + " success:" + (getResultStream()!=null));
	}

	public void changeNodeName(Document doc, Node node, String new_name){
		// Create an element with the new name 
		Node node2 = (Node ) doc.createElement(new_name); 
		// Copy the attributes to the new element NamedNodeMap attrs = element.getAttributes(); for (int i=0; i<attrs.getLength(); i++) { Attr attr2 = (Attr)doc.importNode(attrs.item(i), true); element2.getAttributes().setNamedItem(attr2); } 
		// Move all the children 
		while (node.hasChildNodes()) { node2.appendChild(node.getFirstChild()); } 
		// Replace the old node with the new node
		Admin.notifyUser("replace:" + node2.getNodeName() + "," + node.getNodeName());
		node.getParentNode().replaceChild(node2, node); 
	}

	public String save() throws IOException {
		
        String jsonData = getData();
              
        Admin.notifyUser("JSON data:"+jsonData);
        
        XMLSerializer serializer = new XMLSerializer();
		JSON json = JSONSerializer.toJSON( jsonData );
		serializer.setRootName("WorkspaceProfile");
		serializer.setElementName("item");
        serializer.setTypeHintsEnabled(false); 
       	String xml = serializer.write( json );
       	Admin.notifyUser("XML:" + xml);
       	
       	InputStream is_xml = new ByteArrayInputStream( xml.getBytes( ) );
        
       	Admin.writeToFile(getPath(), is_xml);
   
       	String ret = "1";
		this.setResultStream( new ByteArrayInputStream(ret.getBytes()));
				

		return SUCCESS;
	}


}