package eu.clarin.cmdi.mdservice.model;

import java.io.IOException;
import java.io.InputStream;

import javax.xml.transform.TransformerException;

import eu.clarin.cmdi.mdservice.action.Admin;
import eu.clarin.cmdi.mdservice.action.MDTransformer;

/**
 * Currently not used! Everything is done directly in MDRepoProxyAction.
 *  
 * Meant as Class holding the result of a query (parentQuery)
 * This is a "passive" object, depending on its parentQuery
 * which is setting the resultStream in its execute-method  
 * @author vronk
 *
 */
public class Result {

	/**
	 * available formats
	 */
	public static String XML = "xml";
	public static String HTML = "html";
	public static String HTMLSNIPPET = "htmlsnippet";
	
	private Query parentQuery;
	
	/**
	 * holds the stream receiving data from the provider (MDRepository...)  
	 */
	private InputStream rawresult;
	
	public Result (Query q) {
		parentQuery = q;
	//	transformed_out	= new ByteArrayOutputStream();
		//setResultStream(new ByteArrayOutputStream());
	}
	
		
	/**
	 * this is the main method to get the formatted-result
	 * precondition: the rawresult already arrived, ie parentQuery.execute() already issued  
	 * @param format is passed as the transkey to the transformer
	 * @return the input stream with the formatted/transformed result
	 * @throws IOException
	 * @throws InterruptedException
	 * @throws TransformerException
	 */
	public InputStream getResultStream(String format) throws IOException, InterruptedException, TransformerException {
		String transformkey;
		
		if (format.equals(XML)) {
			return rawresult;
		} else {	
			transformkey = parentQuery.getType() + "2" + format;
			Admin.notifyUser("transformkey: " + transformkey );
			MDTransformer transformer = new MDTransformer();
			transformer.setParams(MDTransformer.createParamsMap(transformkey));
			return transformer.transformXML(rawresult);//, transformkey);
		}	
	}

	/**
	 * without format-parameter, you get the raw-data-stream (XML?) received from the provider
	 * @return
	 */
	public InputStream getResultStream() {
		return rawresult;		
	}

	public void getResultStream(String format, InputStream in) throws IOException, InterruptedException, TransformerException {
			in = getResultStream(format);
	}

	
	public void setInputStream(InputStream in) {
		this.rawresult = in;		
	}

	/**
	 * a stub for a header to be returned with every result
	 * not used yet
	 * @return
	 */
	public String getHeader() {
		String header = "";
			
		header = "<header>";
		header += "<userquery>" + parentQuery.getQueryString() + "</userquery>"; 
		header += "<xpathquery>" + parentQuery.toXPath() + "</xpathquery>";		
		header += "</header>";
		
		
		return header; 
	}

}